#
# spec file for package pure-ftpd (Version 1.0.18)
#
# Copyright (c) 2004 SUSE LINUX AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# norootforbuild
# neededforbuild  mysql-devel mysql-shared openldap2-client openldap2-devel openssl openssl-devel pam-devel postgresql-devel postgresql-libs

BuildRequires: aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libselinux libstdc++ libxcrypt m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils gcc gdbm gettext heimdal-lib libtool mysql-devel mysql-shared openldap2-devel openssl-devel pam-devel perl postgresql-devel postgresql-libs rpm

Name:         pure-ftpd
Version:      1.0.18
Release:      39.4
URL:          http://www.pureftpd.org
Source:       ftp://ftp.pureftpd.org/pub/%name/releases/%name-%version.tar.bz2
Source1:      %name.init
Source2:      %name.pamd
Source3:      %name.xinetd
Patch:        %name-%version.diff
Patch1:       %name-%version-readme.ldap.diff
Patch2:       pure-ftpd-1.0.18-DoSfix.diff
Group:        Productivity/Networking/Ftp/Servers
License:      BSD
Provides:     ftp-server pureftpd
PreReq:       %insserv_prereq
BuildRoot:    %{_tmppath}/%{name}-%{version}-build
Summary:      Lightweight, fast and secure FTP server

%description
Pure-FTPd is a fast, production-quality, standard-comformant FTP
server, based upon Troll-FTPd. Unlike other popular FTP servers, it has
no known security flaw, it is really trivial to set up and it is
especially designed for modern Linux kernels (setfsuid, sendfile,
capabilities) . Features include PAM support, IPv6, chroot()ed home
directories, virtual domains, built-in LS, anti-warez system, bandwidth
throttling, FXP, bounded ports for passive downloads, UL/DL ratios,
Apache log files and more.



%prep
%setup
%patch -p1
%patch1 -p1
%patch2 -p0

%build
CFLAGS="$RPM_OPT_FLAGS" ./configure \
			--prefix=%_prefix \
			--sysconfdir=%_sysconfdir/%name \
			--mandir=%_mandir \
			--with-ldap \
			--with-paranoidmsg \
			--with-altlog \
			--with-virtualhosts \
			--with-ftpwho \
			--with-mysql \
			--with-nonalnum \
			--with-pgsql \
			--with-cookie \
			--with-throttling \
			--with-ratios \
			--with-uploadscript \
			--with-pam \
			--with-puredb \
			--with-sysquotas \
			--with-quotas \
			--with-inetd \
			--with-tls \
			--with-largefile %_target_cpu-suse-linux
make
cat configuration-file/pure-config.pl |grep -v "^print" | grep -v "^exec" > configuration-file/pure-config-args
echo "print join(\" \", @flg);" >> configuration-file/pure-config-args

%install
rm -rf "$RPM_BUILD_ROOT"
make DESTDIR=$RPM_BUILD_ROOT install
mkdir -p $RPM_BUILD_ROOT%_prefix/sbin
mkdir -p $RPM_BUILD_ROOT%_sysconfdir/%name
mkdir -p $RPM_BUILD_ROOT/%_sysconfdir/pam.d
mkdir -p $RPM_BUILD_ROOT/%_sysconfdir/xinetd.d
mkdir -p $RPM_BUILD_ROOT/%_sysconfdir/openldap/schema
mkdir -p $RPM_BUILD_ROOT/%_mandir/man8
mkdir -p $RPM_BUILD_ROOT/%_sysconfdir/init.d
install -m 755 configuration-file/pure-config.pl $RPM_BUILD_ROOT%_prefix/sbin
install -m 755 configuration-file/pure-config-args $RPM_BUILD_ROOT%_prefix/sbin
install -m 644 configuration-file/pure-ftpd.conf \
               $RPM_BUILD_ROOT%_sysconfdir/%name
install -m 755 $RPM_SOURCE_DIR/pure-ftpd.init \
               $RPM_BUILD_ROOT/%_sysconfdir/init.d/pure-ftpd
ln -sf ../../etc/init.d/pure-ftpd $RPM_BUILD_ROOT/%_prefix/sbin/rcpure-ftpd
install -m 644 $RPM_SOURCE_DIR/pure-ftpd.pamd \
               $RPM_BUILD_ROOT/etc/pam.d/pure-ftpd
install -m 644 $RPM_SOURCE_DIR/pure-ftpd.xinetd \
               $RPM_BUILD_ROOT/etc/xinetd.d/pure-ftpd
install -m 644 pureftpd.schema $RPM_BUILD_ROOT/etc/openldap/schema/

%clean
rm -rf "$RPM_BUILD_ROOT"

%preun
%stop_on_removal %name

%post
if [ -f etc/pure-ftpd.conf ]; then
        mv etc/pure-ftpd.conf etc/pure-ftpd/pure-ftpd.conf
fi

%postun
%insserv_cleanup
%restart_on_update %name

%files
%defattr(-, root, root)
%doc AUTHORS CONTACT COPYING NEWS THANKS README README.Contrib
%doc README.Configuration-File HISTORY README.Netfilter README.Virtual-Users
%doc README.LDAP pureftpd-ldap.conf README.MySQL README.PGSQL README.TLS
%dir %_sysconfdir/openldap
%dir %_sysconfdir/openldap/schema
%dir %_sysconfdir/%name
%attr (0644,root,root) %config %_sysconfdir/openldap/schema/pureftpd.schema
%attr (0755,root,root) %_prefix/bin/*
%attr (0755,root,root) %_prefix/sbin/*
%attr (0755,root,root) %config %_sysconfdir/init.d/pure-ftpd
%attr (0644,root,root) %config %_sysconfdir/pam.d/pure-ftpd
%attr (0644,root,root) %doc %_mandir/man8/*
%attr (0644,root,root) %config(noreplace) %_sysconfdir/%name/pure-ftpd.conf
%attr (0644,root,root) %config(noreplace) %_sysconfdir/xinetd.d/pure-ftpd

%changelog -n pure-ftpd
* Thu Jul 08 2004 - mmj@suse.de
- Apply fix to remove possible DoS attacks [#42821]
* Tue Mar 02 2004 - mmj@suse.de
- Reflect in the configuration file that /etc/pure-ftpd/ now is a
  place to keep all the pure-ftpd configuration files.
* Tue Mar 02 2004 - mmj@suse.de
- Move configuration file when updating
- Fix initscript to use /etc/pure-ftpd/pure-ftpd.conf [#35196]
- Update to 1.0.18 including:
  o UTF-8 characters are now supported in file names [#34829]
  o Buglets were fixed in the documentation.
  o Two new translations were added : hungarian and catalan
  o The server now uses distinct IPv4 and IPv6 to listen to both
  protocols on all operating systems. A new switch, -6, forces the
  server to only listen to IPv6.
  o W3C and CLF alternative log formats are now more standard
  conformant.
  o Pure-FTPd can now produce WU-FTPd (xferlog) compatible log files.
  o Support for Rendezvous was added on MacOS X.
  o Support for Apple / GNUStep plist data output was added to
  pure-ftpwho.
* Fri Feb 27 2004 - mmj@suse.de
- Enable mysql and postgresql support, since they provide very
  good functionality with only tiny extra dependencies
- Compile with --with-nonalnum to support non alphanumeric chars
* Fri Jan 16 2004 - kukuk@suse.de
- Add pam-devel to neededforbuild
* Thu Dec 04 2003 - mmj@suse.de
- Update to pure-ftpd v. 1.0.17a
* Wed Oct 15 2003 - mmj@suse.de
- Don't build as root
* Tue Aug 12 2003 - mmj@suse.de
- Update to 1.0.16, with SSL/TLS support and many bugfixes
- Use new macros for stop/restart of services on rpm update/removal
* Sun Jul 27 2003 - mmj@suse.de
- Support system quotas
* Tue Jun 17 2003 - mmj@suse.de
- Update to version 1.0.15:
   A turkish translation has been added.
   Various functional and portability fixes have been made to the
  handling of upload scripts, to the pure-pw command and to the
  automatic creation of home directories.
   Accounts in a puredb database can now be quickly listed.
   The anonymous FTP directory can now be overriden on the Windows
  port (using a WIN32_ANON_DIR environment variable).
   The default banner has been stripped down to look more
  professionnal.
   Transfer speed on BSD systems has been improved.
   The license of the whole package has changed from GPL to a
  simplified BSD license.
* Thu May 15 2003 - mmj@suse.de
- Allow dot-files in general, but prohibit writing of them [#26897]
* Wed Apr 30 2003 - mmj@suse.de
- Apply the detach patch elsewhere to not break xinetd
- Add note to the xinetd conffile about the xinetd behaviour
- Rearrange the specfile a bit
* Thu Mar 06 2003 - mmj@suse.de
- Fix the xinetd configuration file
* Fri Feb 28 2003 - mmj@suse.de
- Add note to README.LDAP about use_ldap in the pam config
* Fri Jan 31 2003 - mmj@suse.de
- Update to 1.0.14 and add a xinetd configuration file just in case
  the user wants to use it with xinetd. Default behaviour is still
  standalone.
* Mon Jan 20 2003 - mmj@suse.de
- Added patch to detach from fd 0, 1 and 2 [#22836]
* Wed Nov 27 2002 - mmj@suse.de
- Update to 1.0.13a which is a minor feature/bugfix-release
* Sat Oct 05 2002 - ckm@suse.de
- Changed default config file to only allow ro anonymous logins,
  and tightened security in case writing is enabled.
* Sat Aug 03 2002 - kukuk@suse.de
- Remove symlinks in postinstall script
- Add PreRequires for insserv
* Thu Jul 04 2002 - kukuk@suse.de
- Update to version 1.0.12 (per-user limits)
* Fri Apr 26 2002 - kukuk@suse.de
- Update to version 1.0.11 (minor bug fixes, better LDAP support)
* Mon Mar 11 2002 - kukuk@suse.de
- Fix permissions
* Sat Feb 16 2002 - kukuk@suse.de
- Fix print arguments [Bug #13389]
* Mon Feb 11 2002 - ro@suse.de
- flgs in perl-config parser is an array
* Thu Jan 24 2002 - kukuk@suse.de
- Update to version 1.0.8
- Compile with LDAP support
* Thu Nov 29 2001 - kukuk@suse.de
- Add pam config file
- Cleanup example config file
* Thu Nov 22 2001 - kukuk@suse.de
- Update to 1.0.3 (rename and quota fixes)
* Thu Nov 01 2001 - kukuk@suse.de
- Initial release of a secure ftp server with LFS
